#!/bin/sh
#------------------------------------------------------------------------------
# /srv/www/admin/ow-refresh.cgi - Device Tree Refresh                   2.0.0
#
# Creation:      04.02.2009 kmw <news4kmw@web.de>
# Last Update:   21.06.2009 kmw
# Modification:  22.06.2009 Tiger
#------------------------------------------------------------------------------

. /srv/www/include/cgi-helper
. /var/run/ow.conf

StatusLED ()
  {
  sl_id=$1
  sl_status=$2
  #--------------
  # Invert signals with heading underscore in port name
  [ -n "`echo $sl_id | grep '\-_'`" ] && sl_status=`expr $sl_status = 0`
  case $sl_status in
    1|on|yes) sl_led=green;;
    0|off|no) sl_led=red;;
    warn)     sl_led=yellow;;
    *)        sl_led=grey;;
  esac
  echo 'parent.document.getElementById("led-'$sl_id'").src="../img/ow-led-'$sl_led'.gif";'
  }

Text ()
  {
  tx_id=$1
  shift
  tx_text=$*
  #--------------
  tx_text=`echo "$tx_text" | sed 's|^[ ]*||;s|[ ]*$||'`
  echo 'parent.document.getElementById("txt-'$tx_id'").value="'"$tx_text"'";'
  }

InputField ()
  {
  if_id=$1
  if_value=$2
  if_unit=$3
  #--------------
  if_value=`echo "$if_value" | sed 's|^[ ]*||;s|[ ]*$||'`
  echo 'parent.document.getElementById("ifd-'$if_id'").value="'"$if_value"'";'
  }

Command ()
  {
  sw_id=$1
  sw_command=$2
  #--------------
  if [ -n "$sw_command" ]
  then
    sw_level=`echo $sw_command | cut -d- -f2-`
    # Invert signals with heading underscore in port name
    [ -n "`echo $sl_id | grep '\-_'`" ] && sl_status=`expr $sl_status = 0`
    case $sw_level in
      1) echo 'parent.document.getElementById("img-'$sw_id'").src="../img/ow-toggle-up.gif";';;
      0) echo 'parent.document.getElementById("img-'$sw_id'").src="../img/ow-toggle-down.gif";';;
      *) echo 'parent.document.getElementById("img-'$sw_id'").src="../img/ow-toggle.gif";';;
    esac
    sw_address=`echo $sw_id | cut -d- -f1`
    echo 'parent.document.getElementById("cmd-'$sw_id'").value="'"$sw_address-$sw_command"'";'
  fi
  }

if [ -x $OW_REFRESH_TEMP ]
then
  # start_time=`date +%s`
  local refresh=
  if [ $OW_REFRESH_INTERVAL -ge 5 ]; then refresh="refresh=$OW_REFRESH_INTERVAL;"; fi
  show_html_header "hidden-ow-refresh" "${refresh}url=$myname;showmenu=no;"
  echo '<script language="JavaScript" type="text/javascript">'
  . $OW_REFRESH_TEMP
  # echo 'parent.document.getElementById("RefreshTime").value="'"$(expr $(date +%s) - $start_time)"'";'
  echo '</script>'
  show_html_footer
fi
